//===================================================================
// Aisa94w.pas
//-------------------------------------------------------------------
// aISA-S94
//
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//===================================================================
unit Aisa94w;

interface

uses
	Windows;

const

	// DLL Name
	AISA94_DLL_NAME								= 'Aisa94.dll';

	// Error code
	AISA94_SUCCESS								= 0;	// ُȂiIj
	AISA94_ERR_SYSTEM							=	1;	// VXeG[
	AISA94_ERR_NO_DEVICE					= 2;	// gp\ȃfoCX܂
	AISA94_ERR_IN_USE							=	3;	// w̃foCX͎gpł
	AISA94_ERR_INVALID_SLOT				=	4;	// Ș_Xbgł
	AISA94_ERR_RESOURCE						=	5;	// \[XG[
	AISA94_ERR_INVALID_PORT				=	6;	// sȃ|[gv
	AISA94_ERR_INVALID_ARG				=	7;	// sȈv܂
	AISA94_ERR_PORT								= 8;  // ȃ|[gł
	AISA94_ERR_INVALID_ADR				= 9;  // ȃAhXł
	AISA94_ERR_BUSY								= 10; // ^pł

	// Misc
	AISA94_SLOT_AUTO							= $FFFF;
	AISA94_MAX_SLOTS							= 16;
	AISA94_ERR_WRAPDLL						= DWord(-1);

	// Memory map ( Word access )
	AISA94_MEM_CMD								= $0000;
	AISA94_MEM_DO									= $0080;
	AISA94_MEM_DI									= $0100;
	AISA94_MEM_C1									= $0180;
	AISA94_MEM_C2									= $0200;
	AISA94_MEM_C3									= $0280;
	AISA94_MEM_C4									= $0300;
	AISA94_MEM_C5									= $0380;
	AISA94_MEM_C6									= $0400;
	AISA94_MEM_DATA								= $0480;

	// Command
	AISA94_CMD_DI_READ						= 0;
	AISA94_CMD_COUNTER1_READ			= 1;
	AISA94_CMD_COUNTER2_READ			= 2;
	AISA94_CMD_COUNTER3_READ			= 3;
	AISA94_CMD_COUNTER4_READ			= 4;
	AISA94_CMD_COUNTER5_READ			= 5;
	AISA94_CMD_COUNTER6_READ			= 6;
	AISA94_CMD_DATA_REG_READ			= 7;
	AISA94_CMD_COUNTER1_CLEAR			= 9;
	AISA94_CMD_COUNTER2_CLEAR			= 10;
	AISA94_CMD_COUNTER3_CLEAR			= 11;
	AISA94_CMD_COUNTER4_CLEAR			= 12;
	AISA94_CMD_COUNTER5_CLEAR			= 13;
	AISA94_CMD_COUNTER6_CLEAR			= 14;

	// Resource information
	AISA94_MAX_MEM								= 9;
	AISA94_MAX_IO									= 20;
	AISA94_MAX_IRQ								= 7;
	AISA94_MAX_DMA								= 7;

type
	TAISA94RESOURCE = record
		dwNumMemWindows:																	DWord;	{ س޳(gp) }
		dwMemBase:			array [1 .. AISA94_MAX_MEM] of	DWord;	{ س޳ްڽ(gp) }
		dwMemLength:		array [1 .. AISA94_MAX_MEM] of	DWord;	{ س޳(gp) }
		dwMemAttrib:		array [1 .. AISA94_MAX_MEM] of	DWord;	{ س޳(gp) }
		dwNumIOPorts:																			DWord;	{ I/O߰Đ }
		dwIOPortBase:		array [1 .. AISA94_MAX_IO] 	of	DWord;	{ I/O߰ްڽ }
		dwIOPortLength: array [1 .. AISA94_MAX_IO] 	of	DWord;	{ I/O߰Ē }
		dwNumIRQs:																				DWord;	{ IRQ(gp) }
		dwIRQRegisters: array [1 .. AISA94_MAX_IRQ] of	DWord;	{ IRQؽ(gp) }
		dwIRQAttrib:		array [1 .. AISA94_MAX_IRQ] of	DWord;	{ IRQؽ(gp) }
		dwNumDMAs:																				DWord;	{ DMAِ(gp) }
		dwDMALst:				array [1 .. AISA94_MAX_DMA] of	DWord;	{ DMAؽ(gp) }
		dwDMAAttrib:		array [1 .. AISA94_MAX_DMA] of	DWord;	{ DMAّؽ(gp) }
		dwReserved1:		array [1 .. 3] of									DWord;	{ \(gp) }
	end;

PAISA94R=^TAISA94RESOURCE;

//DLL [h
function Aisa94wDllOpen:Boolean;
//DLL A[h
function Aisa94wDllClose:Boolean;
//o[Wԍ擾
function Aisa94wGetVersion(var pdwDllVer:DWord; var pdwDrvVer:DWord):Boolean;
//foCX̎gp錾
function Aisa94wCreate(var pwLogSlot:Word):Boolean;
//foCX̊J
function Aisa94wClose(wLogSlot:Word):Boolean;
//\[X擾
function Aisa94wGetResource(wLogSlot:Word;pres:PAISA94R):Boolean;
//G[R[h擾
function Aisa94wGetLastError(wLogSlot:Word):DWord;
//[h
function Aisa94wInpw( wLogSlot,wPort:Word; var pwData:Word ):Boolean;
//[ho
function Aisa94wOutpw( wLogSlot,wPort,wData:Word ):Boolean;
//gkrǂݍ
function Aisa94wMemRead( wLogSlot,wAdr:Word; var pwData:Word ):Boolean;
//gkr
function Aisa94wMemWrite( wLogSlot,wAdr,wData:Word ):Boolean;
//gkr
function Aisa94wInitialize( wLogSlot:Word ):Boolean;
//gkrʐMVXeJn
function Aisa94wStart( wLogSlot, wSNum:Word ):Boolean;
//gkrʐMVXe~
function Aisa94wStop( wLogSlot:Word ):Boolean;
//cGÃAhXɏݎs
function Aisa94wDout( wLogSlot, wSNo, wData:Word ):Boolean;
//cGA̒lǂݍ
function Aisa94wDin( wLogSlot,wSNo:Word; var pwData:Word ):Boolean;
//JE^GA̒lǂݍ
function Aisa94wCntRead( wLogSlot,wSNo,wCntNo:Word; var pwData:Word ):Boolean;
//f[^WX^GA̒lǂݍ
function Aisa94wDRegRead( wLogSlot, wSNo:Word; var pwData:Word ):Boolean;
//Rg[GAɃR}h
function Aisa94wCtrlWrite( wLogSlot, wSNo, wCmd:Word ):Boolean;
//Rg[GAǂݍ
function Aisa94wCtrlRead( wLogSlot, wSNo:Word; var pwValue:Word ):Boolean;

implementation

type
	TAisa94GetVersion		=function(var pdwDllVer:DWord; var pdwDrvVer:DWord):Boolean;stdcall;
	TAisa94Create				=function(var pwLogSlot:Word):Boolean;stdcall;
	TAisa94Close				=function(wLogSlot:Word):Boolean;stdcall;
	TAisa94GetResource  =function(wLogSlot:Word;pres:PAISA94R):Boolean;stdcall;
	TAisa94GetLastError	=function(wLogSlot:Word):Word;stdcall;

	TAisa94Inpw					=function( wLogSlot,wPort:Word; var pwData:Word ):Boolean;stdcall;
	TAisa94Outpw				=function( wLogSlot,wPort,wData:Word ):Boolean;stdcall;
	TAisa94MemRead			=function( wLogSlot,wAdr:Word; var pwData:Word ):Boolean;stdcall;
	TAisa94MemWrite			=function( wLogSlot,wAdr,wData:Word ):Boolean;stdcall;
	TAisa94Initialize		=function( wLogSlot:Word ):Boolean;stdcall;
	TAisa94Start				=function( wLogSlot, wSNum:Word ):Boolean;stdcall;
	TAisa94Stop					=function( wLogSlot:Word ):Boolean;stdcall;
	TAisa94Dout					=function( wLogSlot, wSNo, wData:Word ):Boolean;stdcall;
	TAisa94Din					=function( wLogSlot,wSNo:Word; var pwData:Word ):Boolean;stdcall;
	TAisa94CntRead			=function( wLogSlot,wSNo,wCntNo:Word; var pwData:Word ):Boolean;stdcall;
	TAisa94DRegRead			=function( wLogSlot, wSNo:Word; var pwData:Word ):Boolean;stdcall;
	TAisa94CtrlWrite		=function( wLogSlot, wSNo, wCmd:Word ):Boolean;stdcall;
	TAisa94CtrlRead			=function( wLogSlot, wSNo:Word; var pwValue:Word ):Boolean;stdcall;


function Aisa94wGetDllExportFunc:Boolean;forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

// DLLGNX|[g֐AhX̊i[ϐ
var
	pAisa94GetVersion:		TAisa94GetVersion;
	pAisa94Create:				TAisa94Create;
	pAisa94Close:					TAisa94Close;
	pAisa94GetResource:		TAisa94GetResource;
	pAisa94GetLastError:	TAisa94GetLastError;
	pAisa94Inpw:					TAisa94Inpw;
	pAisa94Outpw:					TAisa94Outpw;
	pAisa94MemRead:				TAisa94MemRead;
	pAisa94MemWrite:			TAisa94MemWrite;
	pAisa94Initialize:		TAisa94Initialize;
	pAisa94Start:					TAisa94Start;
	pAisa94Stop:					TAisa94Stop;
	pAisa94Dout:					TAisa94Dout;
	pAisa94Din:						TAisa94Din;
	pAisa94CntRead:				TAisa94CntRead;
	pAisa94DRegRead:			TAisa94DRegRead;
	pAisa94CtrlWrite:			TAisa94CtrlWrite;
	pAisa94CtrlRead:			TAisa94CtrlRead;


//===================================================================
//   	Aisa94.dll [h
//   	
// ߂l  True
//				s False
//===================================================================
function Aisa94wDllOpen:Boolean;
begin
	Result:=False;
	if hDLL <> 0 then Exit;
	hDLL := LoadLibrary(AISA94_DLL_NAME);
	if hDLL = 0 then Exit;
	if Aisa94wGetDllExportFunc = False then	begin
		Aisa94wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Exit;
	end;
	Result := True;
end;
//===================================================================
//   	Aisa94.dllA[h
//   	
// ߂l  True
//				s False
//===================================================================
function Aisa94wDllClose: Boolean;
begin
	Result := True;
	if hDLL = 0 then Exit;
	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;
//===================================================================
//    o[Wԍ擾
//    pdwDllVer	DLLo[Wԍi[
//        pdwDrvVer	DRVo[Wԍi[
// ߂l  True
//				s False
//===================================================================
function Aisa94wGetVersion(var pdwDllVer:DWord; var pdwDrvVer:DWord):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa94GetVersion(pdwDllVer,pdwDrvVer);
end;
//===================================================================
//    foCX̎gp錾
//    pwLogSlot gpfoCXi[
// ߂l  True
//				s False
//===================================================================
function Aisa94wCreate(var pwLogSlot:Word):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa94Create(pwLogSlot);
end;
//===================================================================
//    foCX̊J
//    wLogSlot	gpfoCX
// ߂l  True
//				s False
//===================================================================
function Aisa94wClose(wLogSlot:Word):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa94Close(wLogSlot);
end;
//===================================================================
//    wfoCX̃\[X擾
//    wLogSlot	foCX
//        pres			\[Xi[\
// ߂l  True
//				s False
//===================================================================
function Aisa94wGetResource(wLogSlot:Word;pres:PAISA94R):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa94GetResource(wLogSlot,pres);
end;
//===================================================================
//    [h
//    wLogSlot	foCX
//				wPort			|[gԍ
//				pwData		̓f[^i[̈ւ̃|C^
// ߂l  True
//				s False
//===================================================================
function Aisa94wInpw( wLogSlot,wPort:Word; var pwData:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa94Inpw(wLogSlot,wPort,pwData);
end;
//===================================================================
//    [ho
//    wLogSlot	foCX
//				wPort			|[gԍ
//				wData			o̓f[^
// ߂l  True
//				s False
//===================================================================
function Aisa94wOutpw( wLogSlot,wPort,wData:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa94Outpw(wLogSlot,wPort,wData);
end;
//===================================================================
//    gkrǂݍ
//    wLogSlot	foCX
//				wAdr			AhX
//				pwData    ǂݍݒli[̈ւ̃|C^
// ߂l  True
//				s False
//===================================================================
function Aisa94wMemRead( wLogSlot,wAdr:Word; var pwData:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa94MemRead(wLogSlot,wAdr,pwData);
end;
//===================================================================
//    gkr
//    wLogSlot	foCX
//				wAdr			AhX
//				wData			ޒl
// ߂l  True
//				s False
//===================================================================
function Aisa94wMemWrite( wLogSlot,wAdr,wData:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa94MemWrite(wLogSlot,wAdr,wData);
end;
//===================================================================
//    gkr
//    wLogSlot	foCX
// ߂l  True
//				s False
//===================================================================
function Aisa94wInitialize( wLogSlot:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa94Initialize(wLogSlot);
end;
//===================================================================
//    gkrʐMVXeJn
//    wLogSlot	foCX
//				wSNum			^pTeCg
// ߂l  True
//				s False
//===================================================================
function Aisa94wStart( wLogSlot, wSNum:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa94Start(wLogSlot,wSNum);
end;
//===================================================================
//    gkrʐMVXe~
//    wLogSlot	foCX
// ߂l  True
//				s False
//===================================================================
function Aisa94wStop( wLogSlot:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa94Stop(wLogSlot);
end;
//===================================================================
//    cGÃAhXɏݎs
//    wLogSlot	foCX
//				wSNo			TeCgm
//				wData			ޒl
// ߂l  True
//				s False
//===================================================================
function Aisa94wDout( wLogSlot, wSNo, wData:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa94Dout(wLogSlot,wSNo,wData);
end;
//===================================================================
//    cGA̒lǂݍ
//    wLogSlot	foCX
//				wSNo			TeCgm
//				pwData		ǂݍݒli[̈ւ̃|C^
// ߂l  True
//				s False
//===================================================================
function Aisa94wDin( wLogSlot,wSNo:Word; var pwData:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa94Din(wLogSlot,wSNo,pwData);
end;
//===================================================================
//    JE^GA̒lǂݍ
//    wLogSlot	foCX
//				wSNo			TeCgm
//				wCntNo		JE^ԍ(1`6)
//				pwData		ǂݍݒli[̈ւ̃|C^
// ߂l  True
//				s False
//===================================================================
function Aisa94wCntRead( wLogSlot,wSNo,wCntNo:Word; var pwData:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa94CntRead(wLogSlot,wSNo,wCntNo,pwData);
end;
//===================================================================
//    f[^WX^GA̒lǂݍ
//    wLogSlot	foCX
//				wSNo			TeCgm
//				pwData		ǂݍݒli[̈ւ̃|C^
// ߂l  True
//				s False
//===================================================================
function Aisa94wDRegRead( wLogSlot, wSNo:Word; var pwData:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa94DRegRead(wLogSlot,wSNo,pwData);
end;
//===================================================================
//    Rg[GAɃR}h
//    wLogSlot	foCX
//				wSNo			TeCgm
//				wCmd			R}h
// ߂l  True
//				s False
//===================================================================
function Aisa94wCtrlWrite( wLogSlot, wSNo, wCmd:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa94CtrlWrite(wLogSlot,wSNo,wCmd);
end;
//===================================================================
//    Rg[GAǂݍ
//    wLogSlot	foCX
//				wSNo			TeCgm
//				pwValue		ǂݍݒli[̈ւ̃|C^
// ߂l  True
//				s False
//===================================================================
function Aisa94wCtrlRead( wLogSlot, wSNo:Word; var pwValue:Word ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa94CtrlRead(wLogSlot,wSNo,pwValue);
end;
//===================================================================
//    G[R[h擾
//    wLogSlot		foCX
// ߂l  True
//        s False
//===================================================================
function Aisa94wGetLastError(wLogSlot:Word):DWord;
begin
	Result := AISA94_ERR_WRAPDLL;
	if hDLL = 0 then Exit;
	Result := pAisa94GetLastError(wLogSlot);
end;
//-------------------------------------------------------------------
//    DLLGNX|[g֐AhX̎擾
//    
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Aisa94wGetDllExportFunc:Boolean;
begin
	Result := False;

	pAisa94GetVersion			:= GetProcAddress(hDLL,'Aisa94GetVersion');
	if @pAisa94GetVersion		= nil then Exit;
	pAisa94Create					:= GetProcAddress(hDLL,'Aisa94Create');
	if @pAisa94Create 			= nil then Exit;
	pAisa94Close					:= GetProcAddress(hDLL,'Aisa94Close');
	if @pAisa94Close 				= nil then Exit;
	pAisa94GetResource		:= GetProcAddress(hDLL,'Aisa94GetResource');
	if @pAisa94GetResource 	= nil then Exit;
	pAisa94GetLastError		:= GetProcAddress(hDLL,'Aisa94GetLastError');
	if @pAisa94GetLastError	= nil then Exit;
	pAisa94Inpw						:= GetProcAddress(hDLL,'Aisa94Inpw');
	if @pAisa94Inpw					= nil then Exit;
	pAisa94Outpw					:= GetProcAddress(hDLL,'Aisa94Outpw');
	if @pAisa94Outpw					= nil then Exit;
	pAisa94MemRead				:= GetProcAddress(hDLL,'Aisa94MemRead');
	if @pAisa94MemRead				= nil then Exit;
	pAisa94MemWrite				:= GetProcAddress(hDLL,'Aisa94MemWrite');
	if @pAisa94MemWrite				= nil then Exit;
	pAisa94Initialize			:= GetProcAddress(hDLL,'Aisa94Initialize');
	if @pAisa94Initialize			= nil then Exit;
	pAisa94Start					:= GetProcAddress(hDLL,'Aisa94Start');
	if @pAisa94Start					= nil then Exit;
	pAisa94Stop						:= GetProcAddress(hDLL,'Aisa94Stop');
	if @pAisa94Stop						= nil then Exit;
	pAisa94Dout						:= GetProcAddress(hDLL,'Aisa94Dout');
	if @pAisa94Dout						= nil then Exit;
	pAisa94Din						:= GetProcAddress(hDLL,'Aisa94Din');
	if @pAisa94Din						= nil then Exit;
	pAisa94CntRead				:= GetProcAddress(hDLL,'Aisa94CntRead');
	if @pAisa94CntRead				= nil then Exit;
	pAisa94DRegRead				:= GetProcAddress(hDLL,'Aisa94DRegRead');
	if @pAisa94DRegRead				= nil then Exit;
	pAisa94CtrlWrite			:= GetProcAddress(hDLL,'Aisa94CtrlWrite');
	if @pAisa94CtrlWrite			= nil then Exit;
	pAisa94CtrlRead				:= GetProcAddress(hDLL,'Aisa94CtrlRead');
	if @pAisa94CtrlRead				= nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.
